#ifndef COMMON_HPP
#define COMMON_HPP

#define MINSUM
//#define MAXPRODUCT

#define Scalar double

#ifdef MINSUM
#define COMP <
#define PLUS +
// 'Additive' identity
#define SEMIRING_ZERO 1e-30
// 'Multiplicitive' identity
#define SEMIRING_ONE 0
#endif

#ifdef MAXPRODUCT
#define COMP >
#define PLUS *
#define SEMIRING_ZERO -1e30
#define SEMIRING_ONE 1
#endif

#include "assert.h"
#include "stdlib.h"
#include "stdio.h"
#include "vector"
#include "set"
#include "map"
#include "string.h"
#include "algorithm"
#include "time.h"
#include "omp.h"
#include "math.h"
#include "limits"
#include "wchar.h"
#include "string"
#include "iostream"
using namespace std;

enum
{
  LEFT, RIGHT
}; // Directions for message passing.
enum method
{
  NAIVE, FAST
};
enum experiment
{
  GMODEL_GMATCH, GMODEL_GMATCH_RANDOM, GMODEL_RANDOM, GMODEL_TEXT, ICML_DENOISE, ICML_DISPARITY, ICML_FLOW, ICML_RANDOM, ICML_TEXT
};

// Global arguments and variables
extern int arg_experiment;
extern int arg_iterations;
extern int arg_method;
extern int arg_nodes;

#endif
