#ifndef EXPERIMENT_HPP
#define EXPERIMENT_HPP

#include "common.hpp"

/** A 2D point. */
template<typename T>
class point
{
  public:
    point() :
      x(0), y(0)
    {
    }
    ;
    point(T x, T y) :
      x(x), y(y)
    {
    }
    ;
    point(const point& p) :
      x(p.x), y(p.y)
    {
    }
    ;
    point operator=(const point& p)
    {
      point a;
      a.x = p.x;
      a.y = p.y;
      return a;
    }
    ~point()
    {
    }
    ;
    T distance1(const point& p)
    {
      return (T) fabs(x - p.x) + fabs(y - p.y);
    }
    ;
  private:
    T x;
    T y;
};

int* gmatch(int method, int M, int N, double& time, int random, int iterations, long long& nread, Scalar& energy);
int* random(int method, int M, int N, double& time, long long& nread, Scalar& energy);

#endif
