#ifndef IMAGEPROCESS
#define IMAGEPROCESS

#include "common.hpp"
#include "CImg.h"

int** improcess(int method, int N, int experiment, double& online, double& total, const char* imleft, const char* imright, Scalar& energy, int& X, int& Y, long long& nread);

cimg_library::CImg<int> readimage(const char* name, int& X, int& Y, int imdim);
void writeimage(const char* name, int** data, int X, int Y, int N);

// Code to compute image statistics.
Scalar smoothness(int value1, int value2, int N, int experiment);
Scalar unary(int x, int y, int value, cimg_library::CImg<int>& left, cimg_library::CImg<int>& right, int N, int experiment);
Scalar** extract_pairwise(int N, cimg_library::CImg<int>& im);

// Smoothness and first-order priors. These methods call the above functions as appropriate.
Scalar** smoothness_mat(int N, int experiment);
Scalar* unary_mat(int x, int y, cimg_library::CImg<int>& left, cimg_library::CImg<int>& right, int N, int experiment);

#endif
