#include "potential.hpp"

void potential::receive(int fromid, int direction, Scalar* message)
{
  map<int, Scalar*>* w = &messagesa;
  if (direction == RIGHT) w = &messagesb;

  if (w->find(fromid) != w->end())
  {
    delete[] w->at(fromid);
    w->erase(fromid);
  }

  w->insert(pair<int, Scalar*> (fromid, message));
}

Scalar* potential::send(int toid, int direction, long long& nread)
{
  Scalar* messagea = new Scalar[N];
  Scalar* messageb = new Scalar[N];
  for (int i = 0; i < N; i++)
  {
    if (pota != NULL)
      messagea[i] = pota[i];
    else
      messagea[i] = SEMIRING_ZERO;

    if (potb != NULL)
      messageb[i] = potb[i];
    else
      messageb[i] = SEMIRING_ZERO;
  }

  for (map<int, Scalar*>::iterator it = messagesa.begin(); it != messagesa.end(); it++)
  {
    int fromid = it->first;
    Scalar* message = it->second;
    if (fromid != toid) for (int i = 0; i < N; i++)
      messagea[i] = messagea[i] PLUS message[i];
  }

  for (map<int, Scalar*>::iterator it = messagesb.begin(); it != messagesb.end(); it++)
  {
    int fromid = it->first;
    Scalar* message = it->second;
    if (fromid != toid) for (int i = 0; i < N; i++)
      messageb[i] = messageb[i] PLUS message[i];
  }

  Scalar* res = new Scalar[N];
  if (direction == LEFT)
    computemarginal(messagea, messageb, pot, Pa, Painv, res, N, method, nread);
  else
    computemarginal(messageb, messagea, pottrans, Pb, Pbinv, res, N, method, nread);

  delete[] messagea;
  delete[] messageb;
  return res;
}

int potential::MAP(int direction, long long& nread)
{
  Scalar* message = send(-1, direction, nread);
  Scalar max = message[0];
  int maxid = 0;
  for (int i = 1; i < N; i++)
    if (message[i] COMP max)
    {
      max = message[i];
      maxid = i;
    }
  delete[] message;
  return maxid;
}
