#ifndef TEXTPROCESS_HPP
#define TEXTPROCESS_HPP

#include "common.hpp"

Scalar* unary_text(wchar_t obs, map<wchar_t, int> alphabet, Scalar prob);
Scalar** text_prior(wchar_t* corpus, map<wchar_t, int> alphabet, int P, int skip, int skipchain);
Scalar smoothness(int value1, int value2, int N, int experiment);

int alphabet_size(const char* corpus, int P, int L, const char* enc);
int* textprocess(int method, const char* corpus, int P, int L, const char* enc, double& time, long long& nread, Scalar noise, int skipchain, int& errs, int& perf, Scalar& energy);

#endif
