#include "util.hpp"

#include "CImg.h"
using namespace cimg_library;

double rnd(void)
{
  return rand() / (1.0 + RAND_MAX);
}

double randnorm(double mean, double deviation)
{
  double uniform;
  double theta, r;
  double x;

  do
  {
    theta = 2.0 * M_PI * rnd();
    uniform = rnd();
    // avoid bombing if the uniform happens to be zero
    if (uniform != 0.0) r = sqrt(-2 * log(uniform));
  }
  while (uniform == 0.0);

  x = r * cos(theta); // from polar to cartesian coordinates

  return mean + x * deviation; // return x coordinate
}
